"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __asyncDelegator = (this && this.__asyncDelegator) || function (o) {
    var i, p;
    return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
    function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
};
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = Object.create((typeof AsyncIterator === "function" ? AsyncIterator : Object).prototype), verb("next"), verb("throw"), verb("return", awaitReturn), i[Symbol.asyncIterator] = function () { return this; }, i;
    function awaitReturn(f) { return function (v) { return Promise.resolve(v).then(f, reject); }; }
    function verb(n, f) { if (g[n]) { i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; if (f) i[n] = f(i[n]); } }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.RecordsV2 = void 0;
const __1 = require("../..");
const core = __importStar(require("../../core"));
const url_join_1 = __importDefault(require("url-join"));
const environments = __importStar(require("../../environments"));
const errors = __importStar(require("../../errors"));
const serializers = __importStar(require("../../serialization"));
const RawResponse_1 = require("../../core/fetcher/RawResponse");
class RecordsV2 {
    constructor(options = {}) {
        this.options = options;
    }
    /**
     * Retrieve records from a sheet in raw JSONL format.
     *
     * This method fetches all records at once and returns them as an array of
     * JsonlRecord objects, which contain the raw data structure from the API
     * including special fields like __k (record ID), __v (version), etc.
     *
     * @param sheetId - The ID of the sheet to retrieve records from
     * @param options - Optional request parameters for filtering, pagination, etc.
     * @param requestOptions - Optional request configuration (headers, timeout, etc.)
     * @returns Promise that resolves to an array of JsonlRecord objects
     *
     * @example
     * ```typescript
     * const rawRecords = await recordsV2.getRaw('us_sh_123', {
     *   fields: ['firstName', 'lastName'],
     *   pageSize: 1000
     * });
     * rawRecords.forEach(record => {
     *   console.log(`Record ID: ${record.__k}`);
     *   console.log(`Field values:`, record);
     * });
     * ```
     */
    getRaw(sheetId_1) {
        return __awaiter(this, arguments, void 0, function* (sheetId, options = {}, requestOptions) {
            const url = yield this._buildUrl(`/v2-alpha/records.jsonl`);
            // Add sheetId and options as query parameters
            const queryParams = this._buildQueryParams(Object.assign(Object.assign({}, options), { sheetId }));
            if (queryParams.length > 0) {
                url.search = queryParams;
            }
            const headers = yield this._prepareHeaders(requestOptions);
            const response = yield this._executeRequest(url.toString(), "GET", {
                headers,
                requestOptions,
            });
            // Parse the JSONL response into an array of records
            const text = yield response.text();
            return this._parseJsonlText(text);
        });
    }
    /**
     * Stream records from a sheet in raw JSONL format.
     *
     * This method provides an async generator that yields JsonlRecord objects
     * as they are received from the server. This is the most memory-efficient
     * way to process large datasets as records are yielded individually rather
     * than loading all records into memory at once.
     *
     * @param sheetId - The ID of the sheet to retrieve records from
     * @param options - Optional request parameters for filtering, pagination, etc.
     * @param requestOptions - Optional request configuration (headers, timeout, etc.)
     * @returns AsyncGenerator that yields JsonlRecord objects
     *
     * @example
     * ```typescript
     * for await (const rawRecord of recordsV2.getRawStreaming('us_sh_123', {
     *   includeTimestamps: true
     * })) {
     *   console.log(`Record ID: ${rawRecord.__k}`);
     *   console.log(`Updated at: ${rawRecord.__u}`);
     *   // Process each record as it streams in
     * }
     * ```
     */
    getRawStreaming(sheetId_1) {
        return __asyncGenerator(this, arguments, function* getRawStreaming_1(sheetId, options = {}, requestOptions = {}) {
            const url = yield __await(this._buildUrl(`/v2-alpha/records.jsonl`));
            // Add sheetId and options as query parameters
            const queryParams = this._buildQueryParams(Object.assign(Object.assign({}, options), { sheetId }));
            if (queryParams.length > 0) {
                url.search = queryParams;
            }
            const headers = yield __await(this._prepareHeaders(requestOptions));
            const response = yield __await(this._executeRequest(url.toString(), "GET", {
                headers,
                requestOptions,
            }));
            // Check if ReadableStream streaming is supported
            if (response.body && typeof response.body.getReader === "function") {
                // Use streaming approach for supported browsers
                yield __await(yield* __asyncDelegator(__asyncValues(this._streamJsonlResponse(response))));
            }
            else {
                // Final fallback for browsers without streaming support
                yield __await(yield* __asyncDelegator(__asyncValues(this._fallbackJsonlResponse(response))));
            }
        });
    }
    /**
     * Stream JSONL response using ReadableStream (modern browsers)
     */
    _streamJsonlResponse(response) {
        return __asyncGenerator(this, arguments, function* _streamJsonlResponse_1() {
            if (!response.body) {
                throw new errors.FlatfileError({
                    message: "Response body is null",
                    rawResponse: undefined,
                });
            }
            const reader = response.body.getReader();
            const decoder = new TextDecoder();
            let buffer = "";
            try {
                while (true) {
                    const { done, value } = yield __await(reader.read());
                    if (done) {
                        // Process any remaining data in buffer
                        if (buffer.trim()) {
                            try {
                                yield yield __await(JSON.parse(buffer.trim()));
                            }
                            catch (error) {
                                // Skip malformed final line
                                console.warn("Failed to parse final JSONL line:", buffer.trim());
                            }
                        }
                        break;
                    }
                    // Decode chunk and add to buffer
                    buffer += decoder.decode(value, { stream: true });
                    // Process complete lines
                    const lines = buffer.split("\n");
                    buffer = lines.pop() || ""; // Keep incomplete line in buffer
                    for (const line of lines) {
                        const trimmedLine = line.trim();
                        if (trimmedLine) {
                            try {
                                yield yield __await(JSON.parse(trimmedLine));
                            }
                            catch (error) {
                                // Skip malformed line but continue streaming
                                console.warn("Failed to parse JSONL line:", trimmedLine);
                            }
                        }
                    }
                }
            }
            finally {
                reader.releaseLock();
            }
        });
    }
    /**
     * Parse JSONL text into an array of JsonlRecord objects
     */
    _parseJsonlText(text) {
        const lines = text.split("\n");
        const records = [];
        for (const line of lines) {
            const trimmedLine = line.trim();
            if (trimmedLine) {
                try {
                    records.push(JSON.parse(trimmedLine));
                }
                catch (error) {
                    console.warn("Failed to parse JSONL line:", trimmedLine);
                }
            }
        }
        return records;
    }
    /**
     * Fallback JSONL processing for browsers without streaming support
     */
    _fallbackJsonlResponse(response) {
        return __asyncGenerator(this, arguments, function* _fallbackJsonlResponse_1() {
            const text = yield __await(response.text());
            const records = this._parseJsonlText(text);
            for (const record of records) {
                yield yield __await(record);
            }
        });
    }
    /**
     * Write records to a sheet in raw JSONL format.
     *
     * This method takes an array of JsonlRecord objects and writes them to the specified sheet.
     * Records can be inserts (no __k field) or updates (with __k field for existing record ID).
     * Supports various write options like truncate, snapshot, and sheet targeting.
     *
     * @param records - Array of JsonlRecord objects to write
     * @param options - Write configuration options
     * @param requestOptions - Optional request configuration (headers, timeout, etc.)
     * @returns Promise that resolves to WriteRecordsResponse with operation results
     *
     * @example
     * ```typescript
     * const records: JsonlRecord[] = [
     *   { firstName: 'John', lastName: 'Doe', __s: 'us_sh_123' },
     *   { __k: 'us_rc_456', firstName: 'Jane', lastName: 'Smith' }  // Update existing
     * ];
     * const result = await recordsV2.writeRaw(records, {
     *   sheetId: 'us_sh_123',
     *   truncate: false
     * });
     * console.log(`Created: ${result.created}, Updated: ${result.updated}`);
     * ```
     */
    writeRaw(records_1) {
        return __awaiter(this, arguments, void 0, function* (records, options = {}, requestOptions = {}) {
            const url = yield this._buildUrl(`/v2-alpha/records.jsonl`);
            // For write operations, ensure all records have the sheet ID set if provided in options
            const enrichedRecords = records.map((record) => {
                // Always ensure sheet ID is present when provided in options
                if (options.sheetId) {
                    return Object.assign({ __s: options.sheetId }, record);
                }
                return record;
            });
            // Add options as query parameters, excluding sheetId since it's in the record body
            const { sheetId: _ } = options, queryOptions = __rest(options, ["sheetId"]);
            const queryParams = this._buildQueryParams(queryOptions, false); // Write operation
            if (queryParams.length > 0) {
                url.search = queryParams;
            }
            // Convert records to JSONL format (one record per line)
            const jsonlBody = enrichedRecords.map((record) => JSON.stringify(record)).join("\n");
            const headers = yield this._prepareHeaders(requestOptions, "application/jsonl");
            // Add sheet ID header if provided in options and not already in records
            if (options.sheetId) {
                headers["X-Sheet-Id"] = options.sheetId;
            }
            const response = yield this._executeRequest(url.toString(), "POST", {
                body: jsonlBody,
                contentType: "application/jsonl",
                headers,
                requestOptions,
            });
            // Parse the response
            const responseBody = yield response.text();
            try {
                return JSON.parse(responseBody);
            }
            catch (error) {
                // If response isn't JSON, return a basic success response
                return { success: true };
            }
        });
    }
    /**
     * Stream records to a sheet in raw JSONL format using HTTP body streaming.
     *
     * This method accepts an async generator/iterator of records and streams them
     * directly to the server using a ReadableStream as the HTTP request body.
     * This approach is memory efficient for large datasets as records are processed
     * and transmitted without loading all data into memory at once.
     *
     * The operation is atomic - all records are sent in a single HTTP request,
     * ensuring consistent write semantics. Records can be new inserts (without __k)
     * or updates to existing records (with __k field containing the record ID).
     *
     * @param recordsStream - Async generator/iterator that yields JsonlRecord objects
     * @param options - Write configuration options (sheetId, truncate, etc.)
     * @param requestOptions - Optional request configuration (headers, timeout, etc.)
     * @returns Promise that resolves to WriteRecordsResponse with operation results
     *
     * @example
     * ```typescript
     * async function* generateRecords() {
     *   for (let i = 0; i < 100000; i++) {
     *     yield {
     *       firstName: `User${i}`,
     *       email: `user${i}@example.com`,
     *       __s: 'us_sh_123'
     *     };
     *   }
     * }
     *
     * const result = await recordsV2.writeRawStreaming(generateRecords(), {
     *   sheetId: 'us_sh_123',
     *   truncate: false
     * });
     * console.log(`Created: ${result.created}, Updated: ${result.updated}`);
     * ```
     */
    writeRawStreaming(recordsStream_1) {
        return __awaiter(this, arguments, void 0, function* (recordsStream, options = {}, requestOptions = {}) {
            const url = yield this._buildUrl(`/v2-alpha/records.jsonl`);
            // Add options as query parameters, excluding sheetId since it's in the record body
            const { sheetId } = options, queryOptions = __rest(options, ["sheetId"]);
            const queryParams = this._buildQueryParams(queryOptions, false); // Write operation
            if (queryParams.length > 0) {
                url.search = queryParams;
            }
            // Create ReadableStream that converts records to JSONL
            const readableStream = new ReadableStream({
                start(controller) {
                    return __awaiter(this, void 0, void 0, function* () {
                        var _a, e_1, _b, _c;
                        const encoder = new TextEncoder();
                        try {
                            try {
                                for (var _d = true, recordsStream_2 = __asyncValues(recordsStream), recordsStream_2_1; recordsStream_2_1 = yield recordsStream_2.next(), _a = recordsStream_2_1.done, !_a; _d = true) {
                                    _c = recordsStream_2_1.value;
                                    _d = false;
                                    const record = _c;
                                    // Ensure sheet ID is set if provided in options
                                    const enrichedRecord = sheetId && !record.__s ? Object.assign(Object.assign({}, record), { __s: sheetId }) : record;
                                    const jsonlLine = JSON.stringify(enrichedRecord) + "\n";
                                    controller.enqueue(encoder.encode(jsonlLine));
                                }
                            }
                            catch (e_1_1) { e_1 = { error: e_1_1 }; }
                            finally {
                                try {
                                    if (!_d && !_a && (_b = recordsStream_2.return)) yield _b.call(recordsStream_2);
                                }
                                finally { if (e_1) throw e_1.error; }
                            }
                            controller.close();
                        }
                        catch (error) {
                            controller.error(error);
                        }
                    });
                },
            });
            const headers = yield this._prepareHeaders(requestOptions, "application/jsonl");
            // Execute the streaming request
            const response = yield this._executeRequest(url.toString(), "POST", {
                body: readableStream, // TypeScript might complain about ReadableStream
                contentType: "application/jsonl",
                headers,
                requestOptions,
            });
            // Parse the response
            const responseBody = yield response.text();
            try {
                return JSON.parse(responseBody);
            }
            catch (error) {
                // If response isn't JSON, return a basic success response
                return { success: true };
            }
        });
    }
    _prepareHeaders(requestOptions_1) {
        return __awaiter(this, arguments, void 0, function* (requestOptions, contentType = "application/json") {
            var _a, _b, _c, _d, _e;
            const authHeader = yield this._getAuthorizationHeader();
            const headers = Object.assign({ "X-Disable-Hooks": (_c = (_a = requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.xDisableHooks) !== null && _a !== void 0 ? _a : (_b = this.options) === null || _b === void 0 ? void 0 : _b.xDisableHooks) !== null && _c !== void 0 ? _c : "true", "X-Fern-Language": "JavaScript", "X-Fern-Runtime": (_d = core.RUNTIME.type) !== null && _d !== void 0 ? _d : "node", "X-Fern-Runtime-Version": (_e = core.RUNTIME.version) !== null && _e !== void 0 ? _e : "unknown", "Content-Type": contentType }, requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.headers);
            // Only add Authorization header if we have a token
            if (authHeader) {
                headers.Authorization = authHeader;
            }
            return headers;
        });
    }
    /**
     * Get authorization header from options
     */
    _getAuthorizationHeader() {
        return __awaiter(this, void 0, void 0, function* () {
            const bearer = yield core.Supplier.get(this.options.token);
            if (bearer != null) {
                return `Bearer ${bearer}`;
            }
            return undefined;
        });
    }
    /**
     * Build full URL from path
     */
    _buildUrl(path) {
        return __awaiter(this, void 0, void 0, function* () {
            var _a, _b;
            let baseUrl = (_b = (_a = (yield core.Supplier.get(this.options.baseUrl))) !== null && _a !== void 0 ? _a : (yield core.Supplier.get(this.options.environment))) !== null && _b !== void 0 ? _b : environments.FlatfileEnvironment.Production;
            // Special handling for v2-alpha endpoints - remove /v1 suffix if present
            if (path.startsWith("/v2-alpha") && baseUrl.endsWith("/v1")) {
                baseUrl = baseUrl.slice(0, -3);
            }
            return new URL((0, url_join_1.default)(baseUrl, path));
        });
    }
    /**
     * Build query parameters string from options object
     */
    _buildQueryParams(params, isReadOperation = true) {
        const searchParams = new URLSearchParams();
        // Only include stream=true for read operations (GET requests)
        if (isReadOperation) {
            searchParams.append("stream", "true");
        }
        for (const [key, value] of Object.entries(params)) {
            if (value !== undefined && value !== null) {
                if (Array.isArray(value)) {
                    // Handle array values (like fields)
                    value.forEach((item) => {
                        if (item !== undefined && item !== null) {
                            searchParams.append(key, String(item));
                        }
                    });
                }
                else {
                    searchParams.append(key, String(value));
                }
            }
        }
        return searchParams.toString();
    }
    /**
     * Execute HTTP request with retry logic and timeout handling
     */
    _executeRequest(url_1, method_1) {
        return __awaiter(this, arguments, void 0, function* (url, method, options = {}) {
            var _a, _b;
            const { body, contentType = "application/json", headers: directHeaders, requestOptions } = options;
            // Prepare headers - merge direct headers with those from requestOptions
            const preparedHeaders = yield this._prepareHeaders(requestOptions, contentType);
            const finalHeaders = Object.assign(Object.assign({}, preparedHeaders), directHeaders);
            // Setup timeout and retry configuration
            const timeoutMs = (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.timeoutInSeconds) != null ? requestOptions.timeoutInSeconds * 1000 : 60000;
            const maxRetries = (_a = requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.maxRetries) !== null && _a !== void 0 ? _a : 0;
            let lastError = null;
            for (let attempt = 0; attempt <= maxRetries; attempt++) {
                const controller = new AbortController();
                let timeoutId = null;
                try {
                    // Setup external abort signal forwarding
                    if (requestOptions === null || requestOptions === void 0 ? void 0 : requestOptions.abortSignal) {
                        requestOptions.abortSignal.addEventListener("abort", () => controller.abort());
                    }
                    // Setup timeout
                    if (timeoutMs > 0) {
                        timeoutId = setTimeout(() => controller.abort(), timeoutMs);
                    }
                    // Prepare fetch options
                    const fetchOptions = {
                        method,
                        headers: finalHeaders,
                        body,
                        signal: controller.signal,
                    };
                    // Add duplex option when body is a ReadableStream (only if ReadableStream is available)
                    if (typeof ReadableStream !== "undefined" && body instanceof ReadableStream) {
                        fetchOptions.duplex = "half";
                    }
                    const response = yield fetch(url, fetchOptions);
                    if (timeoutId) {
                        clearTimeout(timeoutId);
                    }
                    // Handle non-success status codes by throwing appropriate errors
                    if (!response.ok) {
                        const errorBody = yield this._parseErrorBody(response);
                        this._throwErrorForStatus(response.status, errorBody, response);
                    }
                    return response;
                }
                catch (error) {
                    if (timeoutId) {
                        clearTimeout(timeoutId);
                    }
                    // Handle abort/timeout
                    if (error instanceof Error && error.name === "AbortError") {
                        throw new errors.FlatfileTimeoutError(`Timeout exceeded when calling ${method} ${url}.`);
                    }
                    // If this is already a Flatfile error, rethrow it
                    if (error instanceof errors.FlatfileError || error instanceof errors.FlatfileTimeoutError) {
                        throw error;
                    }
                    lastError = error;
                    // If we've exhausted retries, throw the last error
                    if (attempt === maxRetries) {
                        throw new errors.FlatfileError({
                            message: lastError.message,
                            rawResponse: undefined,
                        });
                    }
                    // Wait before retry (exponential backoff)
                    if (attempt < maxRetries) {
                        yield new Promise((resolve) => setTimeout(resolve, Math.pow(2, attempt) * 1000));
                    }
                }
            }
            // This should never be reached, but just in case
            throw new errors.FlatfileError({
                message: (_b = lastError === null || lastError === void 0 ? void 0 : lastError.message) !== null && _b !== void 0 ? _b : "Unknown error occurred",
                rawResponse: undefined,
            });
        });
    }
    /**
     * Parse error body from response
     */
    _parseErrorBody(response) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const text = yield response.text();
                return text ? JSON.parse(text) : {};
            }
            catch (_a) {
                return {};
            }
        });
    }
    /**
     * Throw appropriate error based on HTTP status code
     */
    _throwErrorForStatus(status, errorBody, response) {
        const rawResponse = (0, RawResponse_1.toRawResponse)(response);
        switch (status) {
            case 400:
                throw new __1.Flatfile.BadRequestError(serializers.Errors.parseOrThrow(errorBody, {
                    unrecognizedObjectKeys: "passthrough",
                    allowUnrecognizedUnionMembers: true,
                    allowUnrecognizedEnumValues: true,
                    skipValidation: true,
                    breadcrumbsPrefix: ["response"],
                }), rawResponse);
            case 404:
                throw new __1.Flatfile.NotFoundError(serializers.Errors.parseOrThrow(errorBody, {
                    unrecognizedObjectKeys: "passthrough",
                    allowUnrecognizedUnionMembers: true,
                    allowUnrecognizedEnumValues: true,
                    skipValidation: true,
                    breadcrumbsPrefix: ["response"],
                }), rawResponse);
            default:
                throw new errors.FlatfileError({
                    statusCode: status,
                    body: errorBody,
                    rawResponse: rawResponse,
                });
        }
    }
}
exports.RecordsV2 = RecordsV2;
